Unit QTT3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QTT3R(var RINT :Real; H1 :Real; H2 :Real; H3 :Real;
                var F :Array of Real; N :Integer; M :Integer;
                L :Integer);

implementation

procedure QTT3R(var RINT :Real; H1 :Real; H2 :Real; H3 :Real;
                var F :Array of Real; N :Integer; M :Integer;
                L :Integer);
var
N1,M1,L1,I,J,K :Integer;
label
_1,_2,_3,_4;
begin
N1 := N-1;
M1 := M-1;
L1 := L-1;
RINT := (F[0+0*N+0*N*M]+F[0+0*N+(L-1)*N*M]+F[0+(M-1)*N+0*N*M]+F[0+(M-1)*N+(L-1)*N*M]+F[(N-1)+0*N+0*N*M]+
    F[(N-1)+0*N+(L-1)*N*M]+F[(N-1)+(M-1)*N+0*N*M]+F[(N-1)+(M-1)*N+(L-1)*N*M])/2;
for I:=2 to N1 do
 begin
_1:
  RINT := RINT+(F[(I-1)+0*N+0*N*M]+F[(I-1)+0*N+(L-1)*N*M]+F[(I-1)+(M-1)*N+0*N*M]+F[(I-1)+(M-1)*N+(L-1)*N*M]);
 end;
RINT := RINT/2.0;
for J:=2 to M1 do
 begin
  RINT := RINT+(F[0+(J-1)*N+0*N*M]+F[(N-1)+(J-1)*N+0*N*M]+F[0+(J-1)*N+(L-1)*N*M]+F[(N-1)+(J-1)*N+(L-1)*N*M])/2;
  for I:=2 to N1 do
   begin
_2:
    RINT := RINT+F[(I-1)+(J-1)*N+0*N*M]+F[(I-1)+(J-1)*N+(L-1)*N*M];
   end;
 end;
RINT := RINT/2.0;
for K:=2 to L1 do
 begin
  RINT := RINT+(F[0+0*N+(K-1)*N*M]+F[0+(L-1)*N+(K-1)*N*M]+F[(N-1)+0*N+(K-1)*N*M]+F[(N-1)+(L-1)*N+(K-1)*N*M])/4;
  for I:=2 to N1 do
   begin
_3:
    RINT := RINT+(F[(I-1)+0*N+(K-1)*N*M]+F[(I-1)+(M-1)*N+(K-1)*N*M])/2.0;
   end;
  for J:=2 to M1 do
   begin
    RINT := RINT+(F[0+(J-1)*N+(K-1)*N*M]+F[(N-1)+(J-1)*N+(K-1)*N*M])/2.0;
    for I:=2 to N1 do
     begin
_4:
      RINT := RINT+F[(I-1)+(J-1)*N+(K-1)*N*M];
     end;
   end;
 end;
RINT := RINT*H1*H2*H3;
end;

end.
